# ct_intel_timeseries


### Prerequisites:
- Python programing
- Working knowledge of Pandas and Sklearn
- Basic statistics

### Lesson 1 - Introduction to Time Series
#### Learning Objectives:
- Define time series
- Explain why time series analysis is important
- Identify time series applications
- Explain how to decompose trend, seasonality, and residuals
- Explain how to decompose additive, multiplicative, pseudo-additive models
- Use Python to create a time series forecasting model
#### Topics:
- Introduction to  time series
- Applications of time series
- Examples of time series
- Time series decomposition: Trends, Seasonality, Residuals
- Time series decomposition models: Additive, Multiplicative, Pseudo-Additive

### Lesson 2 - Stationarity 
#### Learning Objectives:
- Define stationarity 
- Explain how to transform nonstationary time series data
- Describe methods for determining stationarity
- Use Python identify nonstationary time series data
#### Topics:
- What is stationarity?
- Why is stationarity important?
- Mathematical transformations: differencing, detrending, logarithms
- Determining stationarity: visualization, gaussian distribution, summary statistics, statistical tests 

### Lesson 3 - Smoothing
#### Learning Objectives:
- Explain the need for data smoothing
- List common data smoothing techniques
- Explain how common data smoothing techniques work
- Use Python to smooth time series data
#### Topics
- Naive Implementation
- Simple Average
- Moving Average
- Weighted Moving Average
- Single Exponential Smoothing
- Double Exponential Smoothing
- Triple Exponential Smoothing (Holt-Winters)

### Lesson 4 - Autocorrelation 
#### Learning Objectives:
- Define autocorrelation
- Describe the autocorrelation and partial autocorrelation functions
- Explain how autoregressive and moving average models work
- Use Python to build autocorrelation models
#### Topics
- Autocorrelation Function (ACF)
- Partial Autocorrelation Function (PACF)
- Autoregressive Models (AR)
- Moving Average Models (MA)
- Identifying AR or MA model

### Lesson 5 - ARMA, ARIMA, and SARIMA
#### Learning Objectives:
- Explain how ARMA, ARIMA, and SARIMA models work
- Describe how to determine the order of p and q
- List common guidelines for building ARMA and ARIMA models
- Use Python to implement ARMA, ARIMA, and SARIMA models
#### Topics
ARMA, ARIMA, and SARIMA Models
Determining the order of p and q
Guidelines
SARIMA

### Lesson 6 - Advanced Time Series 
#### Learning Objectives:
- Describe how to use control charts for anomaly detection
- Explain Kalman filters
- Use Kalman filters for time series analysis
#### Topics
- Anomaly Detection: Control Charts
- Kalman Filters

### Lesson 7 - Signal Transformations
#### Learning Objectives:
- Identify the varieties and usefulness of signal transformations
- Differentiate between various signal transformation techniques
#### Topics
- Sine Wave
- Fourier Transform (FT) and Inverse Fourier Transform (IFT)
- Properties of FT
- Common FT
- Transfer Functions and Bode Plots
- Filters: low pass, high pass, band pass, band stop
- Butterworth Filters
- Window Functions: Hann and Tukey

### Lesson 8 - Time Series through Deep Learning 
#### Learning Objectives:
- Explain how deep learning is used in time series analysis
- Describe RNN and LSTM architectures
- Use Python to implement deep learning models for time series forecasting
#### Topics:
- One to One and One to Many Problem
- Recurrent Neural Networks (RNN)
- Long Short Term Memory (LSTM)
